var SVN_SETTING = {
		pluginName : "CATSVNPlugin",
		savedPrivateKey : "",
		pluginContext : CATPluginManager.getContext("CATSVNPlugin"),
		baseUrl : pluginContext.contextPath,
		invokePropertyFiles : function (){
			//Loading properties for internationalization
			jQuery.i18n.properties({
				name: "messages",
				path: $('#basePath').val()+"/resources/gitResourceStrings/",
				mode: 'both',
				language :PLUGIN_UTIL.getLanguage()
			});
		},
		redirectProjectEditList : function(){
			window.location.href = "/projectManagement/projectEditList?projectId="+$('#projectId').val();
		},
		saveSvnSettings : function(){
			$('#loadingView').show();
			var fieldData;
			var onOffFlag = $("input[name='svnSettingEnable']:checked").val();
			if(onOffFlag == 1){

				var fieldData = {};
            	if( $('#toggleOption').is(':checked') ){
            		fieldData = {
            				"scmEnable" : $("input[name='svnSettingEnable']:checked").val(),
                	    	"projectId": $('#projectId').val(),
                	    	"projectKey": $('#projectKey').val(),
                	    	"scmRepoPath": ($('#svnRepoName').val()).trim(),
                	    	"scmUname" : "",
                	    	"scmPass": "",
                	    	"scmPivateKey": ( $('#hiddenPrivateKey').val() != "" ) ? $('#hiddenPrivateKey').val().trim() : $('#svnPrivateKey').val().trim(),
                	    	"scmPassPhrase" : $('#svnPassPhrase').val().trim(),
                	    	"portNumber":""
	            	};
            	}else{
            		fieldData = {
            				"scmEnable" : $("input[name='svnSettingEnable']:checked").val(),
                	    	"projectId": $('#projectId').val(),
                	    	"projectKey": $('#projectKey').val(),
                	    	"scmRepoPath": ($('#svnRepoName').val()).trim(),
                	    	"scmUname" : "",
                	    	"scmPass": "",
                	    	"scmPivateKey": "",
                	    	"scmPassPhrase" : "",
                	    	"portNumber": ""
	            	};
            	}
			}
			else{
				fieldData = {
            	    	"scmEnable" : $("input[name='svnSettingEnable']:checked").val(),
            	    	"projectId": $('#projectId').val(),
            	    	"projectKey": $('#projectKey').val()
            	};
			}
			$.ajax({
				method: 'POST',
				url: SVN_SETTING.baseUrl + '/saveGitSetting',
				data: fieldData,
				dataType: "json",
				cache: false,
				success : function(response) {
					$('#loadingView').hide();
					//console.log("submit ",response);
					SVN_SETTING.redirectProjectEditList();
				},
				error : function(XMLHttpRequest, textStatus, errorThrown) {
					//console.log(XMLHttpRequest,textStatus,errorThrown);
					$('#loadingView').hide();
					F.pluginDialog("Error " + XMLHttpRequest.status, "Something wrong happens while submitting form", "", "OK", "error", false, {
						width : 300,
					});
				}
			});
		},
		switchIntegrationSettingOnOff : function(onOff){
			$('#svnEnable').val(onOff);
			if(onOff == 0){
				$('.scmRepoType').hide();
				$(".scmRepoLocationRow").hide();
				$(".scmUserNameRow").hide();
				$(".scmPasswordRow").hide();
				$('.scmOptionRow').hide();

				$('#btnSaveSvnSetting').prop('disabled', false);
				$('#testCheckSvnRepo').prop('disabled', true);
				$("#fieldValidationDiv").hide();
			}
			else{
				$('#btnSaveSvnSetting').prop('disabled', true);
				$('#testCheckSvnRepo').prop('disabled', false);
				$("#fieldValidationDiv").hide();

				$('.scmRepoType').show();
				$(".scmRepoLocationRow").show();
				$(".scmUserNameRow").show();
				$(".scmPasswordRow").show();
				$('.scmOptionRow').show();
			}
		},
		clickOnCancelAndRedirect : function(){

			F.confirm(plugin.git.cancelSettingMsg, {
				width : 350,
				height: 80,
				textAlign: 'center',
				on_ok : function() {
					window.location.href = $('#basePath').val() + "/jspHandler?projectId="+$('#projectId').val()+"&projectKey="+$('#projectKey').val();
			    }
		    });
		},
		testSvnRepository : function(){
			//for clear the previous validation highlighted classes
			$('input,textarea,label').removeClass('repo-field-error');
			var errorMsg = "";
			var regxSimpleSsh = new RegExp('(^[0-9a-zA-Z]{3,})([@])([0-9a-zA-Z.-]{1,})([:][0-9a-zA-Z]{1,})?(\/{1}[0-9a-zA-Z-_\/\.]{1,})*$');
			var regxGit = /(^git:\/\/)([0-9a-zA-Z.-]{1,})([:][0-9]{1,})?(\/{1}[0-9a-zA-Z-_\/\.]{1,})*$/g
			var regxSSH = /(^ssh:\/\/)([0-9a-zA-Z-]{3,})([.@])([0-9a-zA-Z.-]{1,})([:][0-9]{1,})?(\/{1}[0-9a-zA-Z-_\/\.]{1,})*$/g
			var repoPath = $('#svnRepoName').val().trim();
			if($('#svnRepoName').val().trim() == ""){
				errorMsg = errorMsg + plugin.git.validation.svnSettingScreen.repositoryValidation + "<br>";
				$('#svnRepoName').addClass("repo-field-error");
			}
			else if(repoPath.indexOf("git://") >= 0 ){
				if( $("#toggleOption").is(':checked')){
					errorMsg = errorMsg + plugin.git.validation.svnSettingScreen.svnProtocolCheckbox + "<br>";
					$('#useSvnSshLabel').addClass('repo-field-error');
				}
				else if( !regxGit.test(repoPath) ){
					errorMsg = errorMsg + plugin.git.validation.svnSettingScreen.gitRepoPathValidation + "<br>";
					$('#svnRepoName').addClass("repo-field-error");
				}
			}
			else if(repoPath.indexOf("ssh://") >= 0 ){
				if(!$("#toggleOption").is(':checked')){
					errorMsg = errorMsg + plugin.git.validation.svnSettingScreen.svnSshProtocolCheckbox + "<br>";
					$('#useSvnSshLabel').addClass('repo-field-error');
				}
				else if($('#svnPrivateKey').is(":visible") && $('#svnPrivateKey').val().trim() == ""){
					errorMsg = errorMsg + plugin.git.validation.svnSettingScreen.svnPrivateKeyValidation + "<br>";
					$('#svnPrivateKey').addClass('repo-field-error');
				}
				else if( !regxSSH.test(repoPath) ){
					errorMsg = errorMsg + plugin.git.validation.svnSettingScreen.sshRepoPathValidation + "<br>";
					$('#svnRepoName').addClass("repo-field-error");
				}
			} 
			else if( regxSimpleSsh.test(repoPath) ){
				if(!$("#toggleOption").is(':checked')){
					errorMsg = errorMsg + plugin.git.validation.svnSettingScreen.svnSshProtocolCheckbox + "<br>";
					$('#useSvnSshLabel').addClass('repo-field-error');
				}else if($('#svnPrivateKey').is(":visible") && $('#svnPrivateKey').val().trim() == ""){
					errorMsg = errorMsg + plugin.git.validation.svnSettingScreen.svnPrivateKeyValidation + "<br>";
					$('#svnPrivateKey').addClass('repo-field-error');
				}
			}
			else {
				errorMsg = errorMsg + plugin.git.validation.svnSettingScreen.checkProtocol + "<br>";
				$('#svnRepoName').addClass("repo-field-error");
			}

			if(errorMsg != ""){
				$('#fieldValidationDiv').html(errorMsg);
				$("#fieldValidationDiv").show();
			}
			else{

				$('input,textarea,label').removeClass('repo-field-error');
				$("#fieldValidationDiv").hide();
				var testConfirmationTitle = plugin.git.testConnectionMessage.testConnectionConfirmation.title;
				var testConfirmationMsg = plugin.git.testConnectionMessage.testConnectionConfirmation.msgBody + "</br>" + $('#svnRepoName').val();
				var testConfirmationOkBtnLabel = plugin.git.htmlLabel.okButtonLabel;
				var testConfirmationCancelBtnLabel = plugin.git.htmlLabel.cancelButtonLabel;

				F.pluginDialog(testConfirmationTitle, testConfirmationMsg, testConfirmationOkBtnLabel, testConfirmationCancelBtnLabel, "question", true, {
					width : 600,
		            on_ok : function() {
		            	$('#loadingView').show();
		            	var svnData = {};
		            	if( $('#toggleOption').is(':checked') ){
		            		svnData = {
			            	    	"svnId" : $('#svnIdDb').val(),
			            	    	"projectId" : $('#projectId').val(),
			            	    	"scmRepoPath": $('#svnRepoName').val().trim(),
			            	    	"scmPivateKey": ( $('#hiddenPrivateKey').val() != "" ) ? $('#hiddenPrivateKey').val().trim() : $('#svnPrivateKey').val().trim(),
			            	    	"scmPassPhrase" : $('#svnPassPhrase').val().trim(),
			            	};
		            	}else{
		            		svnData = {
			            	    	"svnId" : $('#svnIdDb').val(),
			            	    	"projectId" : $('#projectId').val(),
			            	    	"scmRepoPath": $('#svnRepoName').val().trim(),
			            	    	"scmPivateKey": "",
			            	    	"scmPassPhrase" : "",
			            	};
		            	}


						$.ajax({
							method: 'POST',
							url: SVN_SETTING.baseUrl + '/testGitRepository',
							data: svnData,
							dataType: "json",
							cache: false,
							success : function(response) {
								console.log(response);
								$('#loadingView').hide();
								$('#testConnection').val(response.testResponce);
								var testResultTitle = plugin.git.testConnectionMessage.testConnectionResult.title;

								if(response.testResponce == "1"){
									$('#btnSaveSvnSetting').prop('disabled', false);
									var testResultSuccessMsg = plugin.git.testConnectionMessage.testConnectionResultSuccess.msgBody;
									var testResultSuccessSaveBtnLabel = plugin.git.htmlLabel.saveButtonLabel;
									var testResultSuccessCancelBtnLabel = plugin.git.htmlLabel.cancelButtonLabel;
									F.pluginDialog(testResultTitle, testResultSuccessMsg, testResultSuccessSaveBtnLabel, testResultSuccessCancelBtnLabel, "question", true, {
										width : 500,
										on_ok : function() {
											SVN_SETTING.saveSvnSettings();
										}
									});
								}else{
									var testResultFailMsg = plugin.git.testConnectionMessage.testConnectionResultFail.msgBody + "</br></br>" + response.testMsg;
									var testResultFailCancelBtnLabel = plugin.git.htmlLabel.closeButtonLabel;

									F.pluginDialog(testResultTitle, testResultFailMsg, "", testResultFailCancelBtnLabel, "error", false, {
										width : 500,
									});
								}
							},
							error : function(XMLHttpRequest, textStatus, errorThrown) {
								$('#loadingView').hide();
								F.pluginDialog("Error " + XMLHttpRequest.status, "Something wrong happens while submitting form", "", "OK", "error", false, {
									width : 300,
								});
							}
						});
		             }
				});
			}
		},
		setTestRepoFlag : function(){
			$('#btnSaveSvnSetting').prop('disabled', true);
			$('#testConnection').val("0");
		},
		showPrivateKeyBox : function(){
			SVN_SETTING.savedPrivateKey = $('#hiddenPrivateKey').val();
			$('#hiddenPrivateKey').val("");
			SVN_SETTING.setTestRepoFlag();
			$('#svnPrivateKey').show();
			$('#imgClosePrivatekey').show();
		},
		closePrivateKeyBox : function(){
			$('#hiddenPrivateKey').val(SVN_SETTING.savedPrivateKey);
			SVN_SETTING.setTestRepoFlag();
			$('#svnPrivateKey').hide();
			$('#imgClosePrivatekey').hide();
		}
}

$(document).ready(function(){
	$('#toggleOption').change(function(){
		if ($(this).is(':checked')){
			$('#optionTable').show();
			SVN_SETTING.setTestRepoFlag();
		}else{
			$('#optionTable').hide();
			SVN_SETTING.setTestRepoFlag();
		}
	});

	if($('#svnEnable').val() == 0){
		$('.scmRepoType').hide();
		$(".scmRepoLocationRow").hide();
		$('.scmOptionRow').hide();
		$('#optionTable').hide();
		$('#testCheckSvnRepo').prop('disabled', true);
	}
	else {
		var svnSettingDtoJson = JSON.parse($('#jsondata').val());
		$('#testCheckSvnRepo').prop('disabled', false);
		if ($('#repoLocation').length){
			$('#svnRepoName').val($('#repoLocation').val());
		}

		var optTableShow = false;
		if (svnSettingDtoJson.repoPrivateKeyString != null && svnSettingDtoJson.repoPrivateKeyString != ""){
			//$('#svnPrivateKey').val(svnSettingDtoJson.repoPrivateKeyString);
			$('#hiddenPrivateKey').val(svnSettingDtoJson.repoPrivateKeyString);
			$('#svnPrivateKey').hide();
			$('#editPrivateKey').show();
			optTableShow = true;
		}


		if(svnSettingDtoJson.repoPassPhrase != null && svnSettingDtoJson.repoPassPhrase != ""){
			$('#svnPassPhrase').val(svnSettingDtoJson.repoPassPhrase);
			optTableShow = true;
		}
		if (optTableShow) {
			$('#toggleOption').prop('checked', true);
			$('#optionTable').show();
		} else {
			$('#toggleOption').prop('checked', false);
			$('#optionTable').hide();
		}
	}

	//loads the internationalization
	SVN_SETTING.invokePropertyFiles();
	$('#toggleOption').trigger('change');
	$('#main-contents').show();

	$(document).on('click',"#btnEditPrivateKey",SVN_SETTING.showPrivateKeyBox);
	$(document).on('click',"#imgClosePrivatekey",SVN_SETTING.closePrivateKeyBox);
	//$(document).on('click',".CAT-dropdown", CAT_SERVICE.attachmentService.showDropdownAttachment);
});